#if 0
#elif defined(__arm64__) && __arm64__
// Generated by Apple Swift version 5.6.1 (swiftlang-5.6.0.323.66 clang-1316.0.20.12)
#ifndef MADME_IOS_SDK_SWIFT_H
#define MADME_IOS_SDK_SWIFT_H
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wgcc-compat"

#if !defined(__has_include)
# define __has_include(x) 0
#endif
#if !defined(__has_attribute)
# define __has_attribute(x) 0
#endif
#if !defined(__has_feature)
# define __has_feature(x) 0
#endif
#if !defined(__has_warning)
# define __has_warning(x) 0
#endif

#if __has_include(<swift/objc-prologue.h>)
# include <swift/objc-prologue.h>
#endif

#pragma clang diagnostic ignored "-Wauto-import"
#include <Foundation/Foundation.h>
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>

#if !defined(SWIFT_TYPEDEFS)
# define SWIFT_TYPEDEFS 1
# if __has_include(<uchar.h>)
#  include <uchar.h>
# elif !defined(__cplusplus)
typedef uint_least16_t char16_t;
typedef uint_least32_t char32_t;
# endif
typedef float swift_float2  __attribute__((__ext_vector_type__(2)));
typedef float swift_float3  __attribute__((__ext_vector_type__(3)));
typedef float swift_float4  __attribute__((__ext_vector_type__(4)));
typedef double swift_double2  __attribute__((__ext_vector_type__(2)));
typedef double swift_double3  __attribute__((__ext_vector_type__(3)));
typedef double swift_double4  __attribute__((__ext_vector_type__(4)));
typedef int swift_int2  __attribute__((__ext_vector_type__(2)));
typedef int swift_int3  __attribute__((__ext_vector_type__(3)));
typedef int swift_int4  __attribute__((__ext_vector_type__(4)));
typedef unsigned int swift_uint2  __attribute__((__ext_vector_type__(2)));
typedef unsigned int swift_uint3  __attribute__((__ext_vector_type__(3)));
typedef unsigned int swift_uint4  __attribute__((__ext_vector_type__(4)));
#endif

#if !defined(SWIFT_PASTE)
# define SWIFT_PASTE_HELPER(x, y) x##y
# define SWIFT_PASTE(x, y) SWIFT_PASTE_HELPER(x, y)
#endif
#if !defined(SWIFT_METATYPE)
# define SWIFT_METATYPE(X) Class
#endif
#if !defined(SWIFT_CLASS_PROPERTY)
# if __has_feature(objc_class_property)
#  define SWIFT_CLASS_PROPERTY(...) __VA_ARGS__
# else
#  define SWIFT_CLASS_PROPERTY(...)
# endif
#endif

#if __has_attribute(objc_runtime_name)
# define SWIFT_RUNTIME_NAME(X) __attribute__((objc_runtime_name(X)))
#else
# define SWIFT_RUNTIME_NAME(X)
#endif
#if __has_attribute(swift_name)
# define SWIFT_COMPILE_NAME(X) __attribute__((swift_name(X)))
#else
# define SWIFT_COMPILE_NAME(X)
#endif
#if __has_attribute(objc_method_family)
# define SWIFT_METHOD_FAMILY(X) __attribute__((objc_method_family(X)))
#else
# define SWIFT_METHOD_FAMILY(X)
#endif
#if __has_attribute(noescape)
# define SWIFT_NOESCAPE __attribute__((noescape))
#else
# define SWIFT_NOESCAPE
#endif
#if __has_attribute(ns_consumed)
# define SWIFT_RELEASES_ARGUMENT __attribute__((ns_consumed))
#else
# define SWIFT_RELEASES_ARGUMENT
#endif
#if __has_attribute(warn_unused_result)
# define SWIFT_WARN_UNUSED_RESULT __attribute__((warn_unused_result))
#else
# define SWIFT_WARN_UNUSED_RESULT
#endif
#if __has_attribute(noreturn)
# define SWIFT_NORETURN __attribute__((noreturn))
#else
# define SWIFT_NORETURN
#endif
#if !defined(SWIFT_CLASS_EXTRA)
# define SWIFT_CLASS_EXTRA
#endif
#if !defined(SWIFT_PROTOCOL_EXTRA)
# define SWIFT_PROTOCOL_EXTRA
#endif
#if !defined(SWIFT_ENUM_EXTRA)
# define SWIFT_ENUM_EXTRA
#endif
#if !defined(SWIFT_CLASS)
# if __has_attribute(objc_subclassing_restricted)
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# else
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# endif
#endif
#if !defined(SWIFT_RESILIENT_CLASS)
# if __has_attribute(objc_class_stub)
#  define SWIFT_RESILIENT_CLASS(SWIFT_NAME) SWIFT_CLASS(SWIFT_NAME) __attribute__((objc_class_stub))
#  define SWIFT_RESILIENT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_class_stub)) SWIFT_CLASS_NAMED(SWIFT_NAME)
# else
#  define SWIFT_RESILIENT_CLASS(SWIFT_NAME) SWIFT_CLASS(SWIFT_NAME)
#  define SWIFT_RESILIENT_CLASS_NAMED(SWIFT_NAME) SWIFT_CLASS_NAMED(SWIFT_NAME)
# endif
#endif

#if !defined(SWIFT_PROTOCOL)
# define SWIFT_PROTOCOL(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
# define SWIFT_PROTOCOL_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
#endif

#if !defined(SWIFT_EXTENSION)
# define SWIFT_EXTENSION(M) SWIFT_PASTE(M##_Swift_, __LINE__)
#endif

#if !defined(OBJC_DESIGNATED_INITIALIZER)
# if __has_attribute(objc_designated_initializer)
#  define OBJC_DESIGNATED_INITIALIZER __attribute__((objc_designated_initializer))
# else
#  define OBJC_DESIGNATED_INITIALIZER
# endif
#endif
#if !defined(SWIFT_ENUM_ATTR)
# if defined(__has_attribute) && __has_attribute(enum_extensibility)
#  define SWIFT_ENUM_ATTR(_extensibility) __attribute__((enum_extensibility(_extensibility)))
# else
#  define SWIFT_ENUM_ATTR(_extensibility)
# endif
#endif
#if !defined(SWIFT_ENUM)
# define SWIFT_ENUM(_type, _name, _extensibility) enum _name : _type _name; enum SWIFT_ENUM_ATTR(_extensibility) SWIFT_ENUM_EXTRA _name : _type
# if __has_feature(generalized_swift_name)
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME, _extensibility) enum _name : _type _name SWIFT_COMPILE_NAME(SWIFT_NAME); enum SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_ENUM_ATTR(_extensibility) SWIFT_ENUM_EXTRA _name : _type
# else
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME, _extensibility) SWIFT_ENUM(_type, _name, _extensibility)
# endif
#endif
#if !defined(SWIFT_UNAVAILABLE)
# define SWIFT_UNAVAILABLE __attribute__((unavailable))
#endif
#if !defined(SWIFT_UNAVAILABLE_MSG)
# define SWIFT_UNAVAILABLE_MSG(msg) __attribute__((unavailable(msg)))
#endif
#if !defined(SWIFT_AVAILABILITY)
# define SWIFT_AVAILABILITY(plat, ...) __attribute__((availability(plat, __VA_ARGS__)))
#endif
#if !defined(SWIFT_WEAK_IMPORT)
# define SWIFT_WEAK_IMPORT __attribute__((weak_import))
#endif
#if !defined(SWIFT_DEPRECATED)
# define SWIFT_DEPRECATED __attribute__((deprecated))
#endif
#if !defined(SWIFT_DEPRECATED_MSG)
# define SWIFT_DEPRECATED_MSG(...) __attribute__((deprecated(__VA_ARGS__)))
#endif
#if __has_feature(attribute_diagnose_if_objc)
# define SWIFT_DEPRECATED_OBJC(Msg) __attribute__((diagnose_if(1, Msg, "warning")))
#else
# define SWIFT_DEPRECATED_OBJC(Msg) SWIFT_DEPRECATED_MSG(Msg)
#endif
#if !defined(IBSegueAction)
# define IBSegueAction
#endif
#if !defined(SWIFT_EXTERN)
# if defined(__cplusplus)
#  define SWIFT_EXTERN extern "C"
# else
#  define SWIFT_EXTERN extern
# endif
#endif
#if __has_feature(modules)
#if __has_warning("-Watimport-in-framework-header")
#pragma clang diagnostic ignored "-Watimport-in-framework-header"
#endif
@import Foundation;
@import ObjectiveC;
@import UIKit;
#endif

#pragma clang diagnostic ignored "-Wproperty-attribute-mismatch"
#pragma clang diagnostic ignored "-Wduplicate-method-arg"
#if __has_warning("-Wpragma-clang-attribute")
# pragma clang diagnostic ignored "-Wpragma-clang-attribute"
#endif
#pragma clang diagnostic ignored "-Wunknown-pragmas"
#pragma clang diagnostic ignored "-Wnullability"

#if __has_attribute(external_source_symbol)
# pragma push_macro("any")
# undef any
# pragma clang attribute push(__attribute__((external_source_symbol(language="Swift", defined_in="madme_ios_sdk",generated_declaration))), apply_to=any(function,enum,objc_interface,objc_category,objc_protocol))
# pragma pop_macro("any")
#endif





@class NSCoder;
@class NSString;

/// Generic base class for mAdme SDK errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk7MMError")
@interface MMError : NSError
/// Returns an object initialized from data in a given unarchiver.
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
- (nonnull instancetype)initWithDomain:(NSString * _Nonnull)domain code:(NSInteger)code userInfo:(NSDictionary<NSString *, id> * _Nullable)dict SWIFT_UNAVAILABLE;
@end


/// Defines a set of potential mAdme ad-presentation errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk21MMAdPresentationError")
@interface MMAdPresentationError : MMError
/// Indicates that the mAdme SDK does not store any ads that match the selection criteria.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull noAdAvailable;)
+ (MMError * _Nonnull)noAdAvailable SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the mAdme SDK does not support the ad.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull unsupportedAd;)
+ (MMError * _Nonnull)unsupportedAd SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the requested ad is not presentable.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull adNotPresentable;)
+ (MMError * _Nonnull)adNotPresentable SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the user account is not activated.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull accountNotActivated;)
+ (MMError * _Nonnull)accountNotActivated SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the app is dormant.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull appAsleep;)
+ (MMError * _Nonnull)appAsleep SWIFT_WARN_UNUSED_RESULT;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end

/// Defines the presentation context.
typedef SWIFT_ENUM(NSInteger, MMAdPresentationMode, open) {
/// Presents an ad view controller directly.
  MMAdPresentationModeDirect = 0,
/// Presents an ad through a local notification.
  MMAdPresentationModeNotification = 1,
};

enum MMAdPresentationResultState : NSInteger;

/// Protocol that all mAdme ad-presentation results must conform to. Not meant to be adopted by applications.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk30MMAdPresentationResultProtocol_")
@protocol MMAdPresentationResultProtocol
/// Unique identifier of the ad presentation result.
@property (nonatomic, readonly, copy) NSString * _Nonnull identifier;
/// The state gives an insight into the interaction between the user and ad.
@property (nonatomic, readonly) enum MMAdPresentationResultState state;
/// Presentation results may contain optional values, e.g., errors.
@property (nonatomic, readonly, strong) id _Nullable oValue;
@end

/// Possible states of mAdme ad-presentation results.
typedef SWIFT_ENUM(NSInteger, MMAdPresentationResultState, open) {
/// adNotPresented
  MMAdPresentationResultStateAdNotPresented = 0,
/// adViewed
  MMAdPresentationResultStateAdViewed = 1,
/// adTapped
  MMAdPresentationResultStateAdTapped = 2,
/// adViewedAndTapped
  MMAdPresentationResultStateAdViewedAndTapped = 3,
/// adDismissed
  MMAdPresentationResultStateAdDismissed = 4,
/// adNotified
  MMAdPresentationResultStateAdNotified = 5,
/// adNotifyFailed
  MMAdPresentationResultStateAdNotifyFailed = 6,
};

/// Aggregate qualifiers: Either any or all. For example, qualifiers may be used to select mAdme ads whose tags match any or all tags in a given array.
typedef SWIFT_ENUM(NSInteger, MMAggregateQualifier, open) {
/// any
  MMAggregateQualifierAny = 0,
/// all
  MMAggregateQualifierAll = 1,
};

@class UIImage;
@class NSDate;

/// Describes a mAdme campaign.
SWIFT_CLASS("_TtC13madme_ios_sdk10MMCampaign")
@interface MMCampaign : NSObject
/// Id of the campaign.
@property (nonatomic, readonly, copy) NSString * _Nonnull campaignId;
/// [Optional] description of the campaign.
@property (nonatomic, readonly, copy) NSString * _Nullable oDescription;
/// [Optional] thumbnail of the campaign.
@property (nonatomic, readonly, strong) UIImage * _Nullable oThumbnail;
/// Expiry date of the campaign.
@property (nonatomic, readonly, copy) NSDate * _Nonnull validUntil;
/// Set to true if the campaign was marked as favorite by the user.
@property (nonatomic, readonly) BOOL isFavorite;
/// Set of campaign tags (if any).
@property (nonatomic, readonly, copy) NSSet<NSString *> * _Nonnull tags;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end


@interface MMCampaign (SWIFT_EXTENSION(madme_ios_sdk))
@property (nonatomic, readonly, copy) NSString * _Nonnull description;
@end


/// Client applications may adopt this or an inheriting protocol to implement a context for the cached campaign updates. E.g., see also MMViewedNoSurveyNoRatingCampaignContext for a default implementation.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk25MMCampaignContextProtocol_")
@protocol MMCampaignContextProtocol
@property (nonatomic, readonly, copy) NSString * _Nonnull typeRawValue;
@end


/// Client applications may adopt this or an inheriting protocol to provide the context of the cached campaign updates. See also MMCampaignContextProtocol.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk33MMCampaignContextProviderProtocol_")
@protocol MMCampaignContextProviderProtocol
@optional
@property (nonatomic, readonly, strong) id <MMCampaignContextProtocol> _Nonnull campaignContext;
@end


/// Client applications that provide client-specific identifiers must adopt this or an inheriting protocol.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk32MMClientIdentityProviderProtocol_")
@protocol MMClientIdentityProviderProtocol
/// Identifier used for oAuth2 client authentication.
@property (nonatomic, readonly, copy) NSString * _Nonnull oAuth2Id;
/// Secret used for oAuth2 client authentication.
@property (nonatomic, readonly, copy) NSString * _Nonnull oAuth2Secret;
@optional
/// Optional client-related identifiers, such ids may be MSISDNs, application session identifiers, SSO tokens, etc.
@property (nonatomic, readonly, copy) NSDictionary<NSString *, NSString *> * _Nullable oClientIds;
@end



/// Protocol that defines the context of a user account status change.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk40MMUserAccountStatusChangeContextProtocol_")
@protocol MMUserAccountStatusChangeContextProtocol
/// Identifier for correlation purposes.
@property (nonatomic, readonly, copy) NSString * _Nonnull correlationIdentifier;
/// The source of the change. For example, a screen that presents a campaign,
/// a profile screen, etc.
@property (nonatomic, readonly, copy) NSString * _Nonnull source;
/// Must return key: value pairs to be used for logging.
@property (nonatomic, readonly, copy) NSDictionary<NSString *, id> * _Nonnull loggingParameters;
@end


/// Base class for private-init classes. Not meant to be instantiated by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk19MMPrivateInitObject")
@interface MMPrivateInitObject : NSObject
/// Returns a string that describes the contents of the receiver.
@property (nonatomic, readonly, copy) NSString * _Nonnull description;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end


/// Identifies a generic (default) context of a user account status change.
SWIFT_CLASS("_TtC13madme_ios_sdk39MMGenericUserAccountStatusChangeContext")
@interface MMGenericUserAccountStatusChangeContext : MMPrivateInitObject <MMUserAccountStatusChangeContextProtocol>
/// Initialize with a correlationIdentifier and source.
- (nonnull instancetype)initWithCorrelationIdentifier:(NSString * _Nonnull)_correlationIdentifier source:(NSString * _Nonnull)_source OBJC_DESIGNATED_INITIALIZER;
/// Identifier for correlation purposes.
@property (nonatomic, readonly, copy) NSString * _Nonnull correlationIdentifier;
/// The source of the change. For example, a screen that presents a campaign,
/// a profile screen, etc.
@property (nonatomic, readonly, copy) NSString * _Nonnull source;
/// Returns key: value logging pairs for the correlationIdentifier and source.
@property (nonatomic, readonly, copy) NSDictionary<NSString *, id> * _Nonnull loggingParameters;
@end


/// Defines a set of potential mAdme notification-processing errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk29MMNotificationProcessingError")
@interface MMNotificationProcessingError : MMError
/// Indicates that the mAdme SDK does not support the notification.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull unsupportedNotification;)
+ (MMError * _Nonnull)unsupportedNotification SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the mAdme SDK was unable to retrieve the media.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull failedToRetrieveMedia;)
+ (MMError * _Nonnull)failedToRetrieveMedia SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the mAdme SDK was unable to schedule a local notification.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull failedToScheduleLocalNotification;)
+ (MMError * _Nonnull)failedToScheduleLocalNotification SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the mAdme SDK was unable to process the action.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull failedToProcessAction;)
+ (MMError * _Nonnull)failedToProcessAction SWIFT_WARN_UNUSED_RESULT;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end

enum MMNotificationProcessingResultState : NSInteger;

/// Protocol that all mAdme notification processing results must conform to. Not meant to be adopted by applications.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk38MMNotificationProcessingResultProtocol_")
@protocol MMNotificationProcessingResultProtocol
/// Unique identifier of the notification processing result.
@property (nonatomic, readonly, copy) NSString * _Nonnull identifier;
/// The state gives an insight into the processing of the notification.
@property (nonatomic, readonly) enum MMNotificationProcessingResultState state;
/// Processing results may contain optional values, e.g., ad presentation results or errors.
@property (nonatomic, readonly, strong) id _Nullable oValue;
@end

/// Possible states of mAdme notification processing results.
typedef SWIFT_ENUM(NSInteger, MMNotificationProcessingResultState, open) {
/// Notification was not processed
  MMNotificationProcessingResultStateNotificationNotProcessed = 0,
/// Notification was processed successfully
  MMNotificationProcessingResultStateNotificationProcessedSucessfully = 1,
/// Notification was processed unsuccessfully
  MMNotificationProcessingResultStateNotificationProcessedUnsuccessfully = 2,
};


@protocol MMSdkDelegateProtocol;
@class UIViewController;
@class NSURL;
@protocol MMUrlProcessingResultProtocol;
@protocol MMUrlSessionEventsProcessingResultProtocol;
@class UIApplication;
@class UIButton;
@class UITextField;

/// mAdme SDK wrapper. Not meant to be instantiated by apps. Please use the sharedInstance singleton instead.
SWIFT_CLASS("_TtC13madme_ios_sdk5MMSdk")
@interface MMSdk : MMPrivateInitObject
/// The mAdme SDK singleton.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMSdk * _Nonnull sharedInstance;)
+ (MMSdk * _Nonnull)sharedInstance SWIFT_WARN_UNUSED_RESULT;
/// The version of the mAdme SDK.
@property (nonatomic, readonly, copy) NSString * _Nonnull version;
/// References the mAdme SDK delegate, which is mandatory.
@property (nonatomic, weak) id <MMSdkDelegateProtocol> _Null_unspecified delegate;
/// Presents a mAdme ad.
/// \param tags A set of tags to be matched.
///
/// \param tagsAggregateQualifier Instructs the mAdme SDK to present an ad that matched either all or any tags.
///
/// \param adPresentationMode Instructs the mAdme SDK to present an ad either directly, or through a notification.
///
/// \param oParentViewController If provided, the mAdme SDK will use it to present the ad.
///
/// \param oResultClosure If provided, the mAdme SDK will use it to report the result of the presentation. For example, if no ad is available, the result will have an adNotPresented state and an noAdAvailable error oValue. If a video ad is viewed the result will have an adViewed state. Or, if a survey is submitted the result will have an adViewedAndTapped state. Note that when multiple notifications are scheduled oResultClosure will be called for each one of them.
///
- (void)presentAdWithTags:(NSSet<NSString *> * _Nonnull)tags tagsAggregateQualifier:(enum MMAggregateQualifier)tagsAggregateQualifier adPresentationMode:(enum MMAdPresentationMode)adPresentationMode oParentViewController:(UIViewController * _Nullable)oParentViewController oResultClosure:(void (^ _Nullable)(id <MMAdPresentationResultProtocol> _Nonnull))oResultClosure;
/// Processes a mAdme notification payload.
/// \param notificationPayload Must be set to a local or remote notification userInfo.
///
/// \param oActionIdentifier If provided, must be set to the notification’s actionIdentifier.
///
/// \param oResultClosure If provided, the mAdme SDK will use it to report
/// the result of the notification processing. For example, if notificationPayload
/// does not correspond to a mAdme notification, the result will have an notificationNotProcessed
/// state and an unsupportedNotification error oValue.
///
- (void)processWithNotificationPayload:(NSDictionary * _Nonnull)notificationPayload oActionIdentifier:(NSString * _Nullable)oActionIdentifier oResultClosure:(void (^ _Nullable)(id <MMNotificationProcessingResultProtocol> _Nonnull))oResultClosure;
/// Configures the mAdme SDK for the processing of remote notifications. Use this API when the client application is in charge of retrieving the remote-notifications registration token. Please make sure that the remote notifications channel is set in the build-time configuration file to e.g., “FCM” or “APNs”, etc.
/// \param with remoteNotificationsRegistrationToken The FCM/APNs/… token.
///
- (void)configureRemoteNotificationsWith:(NSString * _Nonnull)remoteNotificationsRegistrationToken;
/// Processes a mAdme url.
/// \param url The url to process.
///
/// \param oResultClosure If provided, the mAdme SDK will use it to report
/// the result of the url processing. For example, if the url does not correspond
/// to a mAdme url, the result will have an urlNotProcessed state and an oValue
/// set to unsupportedUrl error.
///
///
/// returns:
/// True if the input url can be processed by the mAdme SDK. False otherwise.
/// Note that although redundant, the return value here allows caller applications
/// to return from “openURL” UIApplicationDelegate calls without having to block
/// waiting for oResultClosure to be called.
- (BOOL)processWithUrl:(NSURL * _Nonnull)url oResultClosure:(void (^ _Nullable)(id <MMUrlProcessingResultProtocol> _Nonnull))oResultClosure SWIFT_WARN_UNUSED_RESULT;
/// Ensures that download events are processed correctly. The application MUST call this
/// each time its delegate receives an application:handleEventsForBackgroundURLSession:completionHandler: call.
/// \param identifier Identifier of the mAdme background download session.
///
/// \param resultClosure Closure to be called once the events have been
/// processed. For example, if the session identifier is not a mAdme session
/// identifier, the result will have an eventsNotProcessed state and an oValue
/// set to unsupportedUrlSessionIdentifier error.
///
- (void)handleEventsForBackgroundURLSessionWithIdentifier:(NSString * _Nonnull)identifier resultClosure:(void (^ _Nonnull)(id <MMUrlSessionEventsProcessingResultProtocol> _Nonnull))resultClosure;
/// Allows the mAdme SDK to perform background tasks. The application MUST call this each time its delegate receives an application:performFetchWithCompletionHandler:.
/// \param application Calling application that embeds the mAdme SDK.
///
/// \param performFetchWithCompletionHandler Closure that will be executed on completion of the tasks.
///
- (void)application:(UIApplication * _Nonnull)application performFetchWithCompletionHandler:(void (^ _Nonnull)(UIBackgroundFetchResult))completionHandler;
/// Configures UI attributes of the input button.
/// \param button Button to be configured.
///
/// \param withUIAttributesId Id of the MMConfiguration UIAttributes entry.
///
- (void)configureButton:(UIButton * _Nonnull)button withUIAttributesId:(NSString * _Nonnull)id;
/// Configures UI attributes of the input textField.
/// \param textField TextField to be configured.
///
/// \param withUIAttributesId Id of the MMConfiguration UIAttributes entry.
///
- (void)configureTextField:(UITextField * _Nonnull)textField withUIAttributesId:(NSString * _Nonnull)id;
@end



@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Call once to configure mAdme notification categories.
+ (void)configureNotificationCategories;
@end


@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Use this key to retrieve the set of campaigns from a Campaigns notification.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, copy) NSString * _Nonnull CampaignsKey;)
+ (NSString * _Nonnull)CampaignsKey SWIFT_WARN_UNUSED_RESULT;
@end

enum MMUserAccountStatus : NSInteger;

@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Retrieves the current user account status.
/// \param closure Closure on which the current user account status is reported.
///
- (void)getUserAccountStatusWithClosure:(void (^ _Nonnull)(enum MMUserAccountStatus))closure;
/// Attempts to re-set the user account status.
/// \param to The target user account status.
///
/// \param changeContext The context in which the account status change takes place.
///
/// \param closure Closure on which the resulting user account status is reported.
///
- (void)changeUserAccountStatusTo:(enum MMUserAccountStatus)userAccountStatus changeContext:(id <MMUserAccountStatusChangeContextProtocol> _Nonnull)changeContext closure:(void (^ _Nonnull)(enum MMUserAccountStatus))closure;
@end


SWIFT_AVAILABILITY(ios,introduced=13.0)
@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Call once to configure mAdme for the processing of background refresh tasks.
+ (void)configureBackgroundRefresh SWIFT_AVAILABILITY(ios,introduced=13.0);
@end


SWIFT_AVAILABILITY(ios,introduced=13.0)
@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Call once to configure mAdme for the processing of background processing tasks.
+ (void)configureBackgroundProcessing SWIFT_AVAILABILITY(ios,introduced=13.0);
@end


@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Returns true if configured through MMConfiguration.plist to manage the style of the status bar. False otherwise.
@property (nonatomic, readonly) BOOL managesStatusBarStyle;
/// Returns the status bar style as configured through MMConfiguration.plist. Defaults to <code>default</code> if not configured.
@property (nonatomic, readonly) UIStatusBarStyle configurationStatusBarStyle;
@end


/// Client applications that require custom opt-in/opt-out behavior must adopt this or an inheriting protocol.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk35MMUserAccountStatusDelegateProtocol_")
@protocol MMUserAccountStatusDelegateProtocol
@optional
/// Called when the user account status is about to be changed.
/// \param to The target user account status.
///
/// \param closure Closure to be used by the delegate to allow for the change to be attempted or aborted. If not implemented, the SDK will allow for the change to be attempted.
///
- (void)willPerformUserAccountStatusChangeTo:(enum MMUserAccountStatus)userAccountStatus closure:(void (^ _Nonnull)(BOOL))closure;
@end


/// mAdme SDK umbrella protocol. Client applications should adopt this protocol instead of the inherited protocols.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk21MMSdkDelegateProtocol_")
@protocol MMSdkDelegateProtocol <MMCampaignContextProviderProtocol, MMClientIdentityProviderProtocol, MMUserAccountStatusDelegateProtocol>
@end


/// Defines a set of potential mAdme url-processing errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk20MMUrlProcessingError")
@interface MMUrlProcessingError : MMError
/// Indicates that the mAdme SDK does not support the url.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull unsupportedUrl;)
+ (MMError * _Nonnull)unsupportedUrl SWIFT_WARN_UNUSED_RESULT;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end

enum MMUrlProcessingResultState : NSInteger;

/// Protocol that all mAdme url processing results must conform to. Not meant to be adopted by applications.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk29MMUrlProcessingResultProtocol_")
@protocol MMUrlProcessingResultProtocol
/// The state gives an insight into the processing of the url.
@property (nonatomic, readonly) enum MMUrlProcessingResultState state;
/// Processing results may contain optional values, e.g., errors.
@property (nonatomic, readonly, strong) id _Nullable oValue;
@end

/// Possible states of mAdme url processing results.
typedef SWIFT_ENUM(NSInteger, MMUrlProcessingResultState, open) {
/// Url was not processed
  MMUrlProcessingResultStateUrlNotProcessed = 0,
/// Url was processed successfully
  MMUrlProcessingResultStateUrlProcessedSucessfully = 1,
/// Url was processed unsuccessfully
  MMUrlProcessingResultStateUrlProcessedUnsuccessfully = 2,
};


/// Defines a set of potential mAdme url-session events processing errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk33MMUrlSessionEventsProcessingError")
@interface MMUrlSessionEventsProcessingError : MMError
/// Indicates that the mAdme SDK does not support the url-session identifier.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull unsupportedUrlSessionIdentifier;)
+ (MMError * _Nonnull)unsupportedUrlSessionIdentifier SWIFT_WARN_UNUSED_RESULT;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end

enum MMUrlSessionEventsProcessingResultState : NSInteger;

/// Protocol that all mAdme url-session events processing results must conform to. Not meant to be adopted by applications.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk42MMUrlSessionEventsProcessingResultProtocol_")
@protocol MMUrlSessionEventsProcessingResultProtocol
/// The state gives an insight into the processing of the events.
@property (nonatomic, readonly) enum MMUrlSessionEventsProcessingResultState state;
/// Processing results may contain optional values, e.g., errors.
@property (nonatomic, readonly, strong) id _Nullable oValue;
@end

/// Possible states of mAdme url-session event processing results.
typedef SWIFT_ENUM(NSInteger, MMUrlSessionEventsProcessingResultState, open) {
/// Events were not processed
  MMUrlSessionEventsProcessingResultStateEventsNotProcessed = 0,
/// Events were processed successfully
  MMUrlSessionEventsProcessingResultStateEventsProcessedSucessfully = 1,
/// Events were processed unsuccessfully
  MMUrlSessionEventsProcessingResultStateEventsProcessedUnsuccessfully = 2,
};

/// Possible states of mAdme user accounts.
typedef SWIFT_ENUM(NSInteger, MMUserAccountStatus, open) {
/// unknown
  MMUserAccountStatusUnknown = 0,
/// activated (opted in)
  MMUserAccountStatusActivated = 1,
/// suspended (opted out)
  MMUserAccountStatusSuspended = 2,
/// terminated
  MMUserAccountStatusTerminated = 3,
};















/// Default campaign context implementation.
SWIFT_CLASS("_TtC13madme_ios_sdk39MMViewedNoSurveyNoRatingCampaignContext")
@interface MMViewedNoSurveyNoRatingCampaignContext : NSObject <MMCampaignContextProtocol>
@property (nonatomic, readonly, copy) NSString * _Nonnull typeRawValue;
- (nonnull instancetype)init OBJC_DESIGNATED_INITIALIZER;
@end






@interface NSNotification (SWIFT_EXTENSION(madme_ios_sdk))
/// Use this as notification name to be informed of cached campaigns updates. See also MMCampaignContextProviderProtocol.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly) NSNotificationName _Nonnull Campaigns;)
+ (NSNotificationName _Nonnull)Campaigns SWIFT_WARN_UNUSED_RESULT;
@end









@interface UINavigationController (SWIFT_EXTENSION(madme_ios_sdk))
/// Returns the topViewController. Override preferredStatusBarStyle in topViewController to control the style of the status bar.
@property (nonatomic, readonly, strong) UIViewController * _Nullable childViewControllerForStatusBarStyle;
@end




#if __has_attribute(external_source_symbol)
# pragma clang attribute pop
#endif
#pragma clang diagnostic pop
#endif

#elif defined(__x86_64__) && __x86_64__
// Generated by Apple Swift version 5.6.1 (swiftlang-5.6.0.323.66 clang-1316.0.20.12)
#ifndef MADME_IOS_SDK_SWIFT_H
#define MADME_IOS_SDK_SWIFT_H
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wgcc-compat"

#if !defined(__has_include)
# define __has_include(x) 0
#endif
#if !defined(__has_attribute)
# define __has_attribute(x) 0
#endif
#if !defined(__has_feature)
# define __has_feature(x) 0
#endif
#if !defined(__has_warning)
# define __has_warning(x) 0
#endif

#if __has_include(<swift/objc-prologue.h>)
# include <swift/objc-prologue.h>
#endif

#pragma clang diagnostic ignored "-Wauto-import"
#include <Foundation/Foundation.h>
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>

#if !defined(SWIFT_TYPEDEFS)
# define SWIFT_TYPEDEFS 1
# if __has_include(<uchar.h>)
#  include <uchar.h>
# elif !defined(__cplusplus)
typedef uint_least16_t char16_t;
typedef uint_least32_t char32_t;
# endif
typedef float swift_float2  __attribute__((__ext_vector_type__(2)));
typedef float swift_float3  __attribute__((__ext_vector_type__(3)));
typedef float swift_float4  __attribute__((__ext_vector_type__(4)));
typedef double swift_double2  __attribute__((__ext_vector_type__(2)));
typedef double swift_double3  __attribute__((__ext_vector_type__(3)));
typedef double swift_double4  __attribute__((__ext_vector_type__(4)));
typedef int swift_int2  __attribute__((__ext_vector_type__(2)));
typedef int swift_int3  __attribute__((__ext_vector_type__(3)));
typedef int swift_int4  __attribute__((__ext_vector_type__(4)));
typedef unsigned int swift_uint2  __attribute__((__ext_vector_type__(2)));
typedef unsigned int swift_uint3  __attribute__((__ext_vector_type__(3)));
typedef unsigned int swift_uint4  __attribute__((__ext_vector_type__(4)));
#endif

#if !defined(SWIFT_PASTE)
# define SWIFT_PASTE_HELPER(x, y) x##y
# define SWIFT_PASTE(x, y) SWIFT_PASTE_HELPER(x, y)
#endif
#if !defined(SWIFT_METATYPE)
# define SWIFT_METATYPE(X) Class
#endif
#if !defined(SWIFT_CLASS_PROPERTY)
# if __has_feature(objc_class_property)
#  define SWIFT_CLASS_PROPERTY(...) __VA_ARGS__
# else
#  define SWIFT_CLASS_PROPERTY(...)
# endif
#endif

#if __has_attribute(objc_runtime_name)
# define SWIFT_RUNTIME_NAME(X) __attribute__((objc_runtime_name(X)))
#else
# define SWIFT_RUNTIME_NAME(X)
#endif
#if __has_attribute(swift_name)
# define SWIFT_COMPILE_NAME(X) __attribute__((swift_name(X)))
#else
# define SWIFT_COMPILE_NAME(X)
#endif
#if __has_attribute(objc_method_family)
# define SWIFT_METHOD_FAMILY(X) __attribute__((objc_method_family(X)))
#else
# define SWIFT_METHOD_FAMILY(X)
#endif
#if __has_attribute(noescape)
# define SWIFT_NOESCAPE __attribute__((noescape))
#else
# define SWIFT_NOESCAPE
#endif
#if __has_attribute(ns_consumed)
# define SWIFT_RELEASES_ARGUMENT __attribute__((ns_consumed))
#else
# define SWIFT_RELEASES_ARGUMENT
#endif
#if __has_attribute(warn_unused_result)
# define SWIFT_WARN_UNUSED_RESULT __attribute__((warn_unused_result))
#else
# define SWIFT_WARN_UNUSED_RESULT
#endif
#if __has_attribute(noreturn)
# define SWIFT_NORETURN __attribute__((noreturn))
#else
# define SWIFT_NORETURN
#endif
#if !defined(SWIFT_CLASS_EXTRA)
# define SWIFT_CLASS_EXTRA
#endif
#if !defined(SWIFT_PROTOCOL_EXTRA)
# define SWIFT_PROTOCOL_EXTRA
#endif
#if !defined(SWIFT_ENUM_EXTRA)
# define SWIFT_ENUM_EXTRA
#endif
#if !defined(SWIFT_CLASS)
# if __has_attribute(objc_subclassing_restricted)
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# else
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# endif
#endif
#if !defined(SWIFT_RESILIENT_CLASS)
# if __has_attribute(objc_class_stub)
#  define SWIFT_RESILIENT_CLASS(SWIFT_NAME) SWIFT_CLASS(SWIFT_NAME) __attribute__((objc_class_stub))
#  define SWIFT_RESILIENT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_class_stub)) SWIFT_CLASS_NAMED(SWIFT_NAME)
# else
#  define SWIFT_RESILIENT_CLASS(SWIFT_NAME) SWIFT_CLASS(SWIFT_NAME)
#  define SWIFT_RESILIENT_CLASS_NAMED(SWIFT_NAME) SWIFT_CLASS_NAMED(SWIFT_NAME)
# endif
#endif

#if !defined(SWIFT_PROTOCOL)
# define SWIFT_PROTOCOL(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
# define SWIFT_PROTOCOL_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
#endif

#if !defined(SWIFT_EXTENSION)
# define SWIFT_EXTENSION(M) SWIFT_PASTE(M##_Swift_, __LINE__)
#endif

#if !defined(OBJC_DESIGNATED_INITIALIZER)
# if __has_attribute(objc_designated_initializer)
#  define OBJC_DESIGNATED_INITIALIZER __attribute__((objc_designated_initializer))
# else
#  define OBJC_DESIGNATED_INITIALIZER
# endif
#endif
#if !defined(SWIFT_ENUM_ATTR)
# if defined(__has_attribute) && __has_attribute(enum_extensibility)
#  define SWIFT_ENUM_ATTR(_extensibility) __attribute__((enum_extensibility(_extensibility)))
# else
#  define SWIFT_ENUM_ATTR(_extensibility)
# endif
#endif
#if !defined(SWIFT_ENUM)
# define SWIFT_ENUM(_type, _name, _extensibility) enum _name : _type _name; enum SWIFT_ENUM_ATTR(_extensibility) SWIFT_ENUM_EXTRA _name : _type
# if __has_feature(generalized_swift_name)
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME, _extensibility) enum _name : _type _name SWIFT_COMPILE_NAME(SWIFT_NAME); enum SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_ENUM_ATTR(_extensibility) SWIFT_ENUM_EXTRA _name : _type
# else
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME, _extensibility) SWIFT_ENUM(_type, _name, _extensibility)
# endif
#endif
#if !defined(SWIFT_UNAVAILABLE)
# define SWIFT_UNAVAILABLE __attribute__((unavailable))
#endif
#if !defined(SWIFT_UNAVAILABLE_MSG)
# define SWIFT_UNAVAILABLE_MSG(msg) __attribute__((unavailable(msg)))
#endif
#if !defined(SWIFT_AVAILABILITY)
# define SWIFT_AVAILABILITY(plat, ...) __attribute__((availability(plat, __VA_ARGS__)))
#endif
#if !defined(SWIFT_WEAK_IMPORT)
# define SWIFT_WEAK_IMPORT __attribute__((weak_import))
#endif
#if !defined(SWIFT_DEPRECATED)
# define SWIFT_DEPRECATED __attribute__((deprecated))
#endif
#if !defined(SWIFT_DEPRECATED_MSG)
# define SWIFT_DEPRECATED_MSG(...) __attribute__((deprecated(__VA_ARGS__)))
#endif
#if __has_feature(attribute_diagnose_if_objc)
# define SWIFT_DEPRECATED_OBJC(Msg) __attribute__((diagnose_if(1, Msg, "warning")))
#else
# define SWIFT_DEPRECATED_OBJC(Msg) SWIFT_DEPRECATED_MSG(Msg)
#endif
#if !defined(IBSegueAction)
# define IBSegueAction
#endif
#if !defined(SWIFT_EXTERN)
# if defined(__cplusplus)
#  define SWIFT_EXTERN extern "C"
# else
#  define SWIFT_EXTERN extern
# endif
#endif
#if __has_feature(modules)
#if __has_warning("-Watimport-in-framework-header")
#pragma clang diagnostic ignored "-Watimport-in-framework-header"
#endif
@import Foundation;
@import ObjectiveC;
@import UIKit;
#endif

#pragma clang diagnostic ignored "-Wproperty-attribute-mismatch"
#pragma clang diagnostic ignored "-Wduplicate-method-arg"
#if __has_warning("-Wpragma-clang-attribute")
# pragma clang diagnostic ignored "-Wpragma-clang-attribute"
#endif
#pragma clang diagnostic ignored "-Wunknown-pragmas"
#pragma clang diagnostic ignored "-Wnullability"

#if __has_attribute(external_source_symbol)
# pragma push_macro("any")
# undef any
# pragma clang attribute push(__attribute__((external_source_symbol(language="Swift", defined_in="madme_ios_sdk",generated_declaration))), apply_to=any(function,enum,objc_interface,objc_category,objc_protocol))
# pragma pop_macro("any")
#endif





@class NSCoder;
@class NSString;

/// Generic base class for mAdme SDK errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk7MMError")
@interface MMError : NSError
/// Returns an object initialized from data in a given unarchiver.
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
- (nonnull instancetype)initWithDomain:(NSString * _Nonnull)domain code:(NSInteger)code userInfo:(NSDictionary<NSString *, id> * _Nullable)dict SWIFT_UNAVAILABLE;
@end


/// Defines a set of potential mAdme ad-presentation errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk21MMAdPresentationError")
@interface MMAdPresentationError : MMError
/// Indicates that the mAdme SDK does not store any ads that match the selection criteria.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull noAdAvailable;)
+ (MMError * _Nonnull)noAdAvailable SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the mAdme SDK does not support the ad.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull unsupportedAd;)
+ (MMError * _Nonnull)unsupportedAd SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the requested ad is not presentable.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull adNotPresentable;)
+ (MMError * _Nonnull)adNotPresentable SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the user account is not activated.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull accountNotActivated;)
+ (MMError * _Nonnull)accountNotActivated SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the app is dormant.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull appAsleep;)
+ (MMError * _Nonnull)appAsleep SWIFT_WARN_UNUSED_RESULT;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end

/// Defines the presentation context.
typedef SWIFT_ENUM(NSInteger, MMAdPresentationMode, open) {
/// Presents an ad view controller directly.
  MMAdPresentationModeDirect = 0,
/// Presents an ad through a local notification.
  MMAdPresentationModeNotification = 1,
};

enum MMAdPresentationResultState : NSInteger;

/// Protocol that all mAdme ad-presentation results must conform to. Not meant to be adopted by applications.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk30MMAdPresentationResultProtocol_")
@protocol MMAdPresentationResultProtocol
/// Unique identifier of the ad presentation result.
@property (nonatomic, readonly, copy) NSString * _Nonnull identifier;
/// The state gives an insight into the interaction between the user and ad.
@property (nonatomic, readonly) enum MMAdPresentationResultState state;
/// Presentation results may contain optional values, e.g., errors.
@property (nonatomic, readonly, strong) id _Nullable oValue;
@end

/// Possible states of mAdme ad-presentation results.
typedef SWIFT_ENUM(NSInteger, MMAdPresentationResultState, open) {
/// adNotPresented
  MMAdPresentationResultStateAdNotPresented = 0,
/// adViewed
  MMAdPresentationResultStateAdViewed = 1,
/// adTapped
  MMAdPresentationResultStateAdTapped = 2,
/// adViewedAndTapped
  MMAdPresentationResultStateAdViewedAndTapped = 3,
/// adDismissed
  MMAdPresentationResultStateAdDismissed = 4,
/// adNotified
  MMAdPresentationResultStateAdNotified = 5,
/// adNotifyFailed
  MMAdPresentationResultStateAdNotifyFailed = 6,
};

/// Aggregate qualifiers: Either any or all. For example, qualifiers may be used to select mAdme ads whose tags match any or all tags in a given array.
typedef SWIFT_ENUM(NSInteger, MMAggregateQualifier, open) {
/// any
  MMAggregateQualifierAny = 0,
/// all
  MMAggregateQualifierAll = 1,
};

@class UIImage;
@class NSDate;

/// Describes a mAdme campaign.
SWIFT_CLASS("_TtC13madme_ios_sdk10MMCampaign")
@interface MMCampaign : NSObject
/// Id of the campaign.
@property (nonatomic, readonly, copy) NSString * _Nonnull campaignId;
/// [Optional] description of the campaign.
@property (nonatomic, readonly, copy) NSString * _Nullable oDescription;
/// [Optional] thumbnail of the campaign.
@property (nonatomic, readonly, strong) UIImage * _Nullable oThumbnail;
/// Expiry date of the campaign.
@property (nonatomic, readonly, copy) NSDate * _Nonnull validUntil;
/// Set to true if the campaign was marked as favorite by the user.
@property (nonatomic, readonly) BOOL isFavorite;
/// Set of campaign tags (if any).
@property (nonatomic, readonly, copy) NSSet<NSString *> * _Nonnull tags;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end


@interface MMCampaign (SWIFT_EXTENSION(madme_ios_sdk))
@property (nonatomic, readonly, copy) NSString * _Nonnull description;
@end


/// Client applications may adopt this or an inheriting protocol to implement a context for the cached campaign updates. E.g., see also MMViewedNoSurveyNoRatingCampaignContext for a default implementation.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk25MMCampaignContextProtocol_")
@protocol MMCampaignContextProtocol
@property (nonatomic, readonly, copy) NSString * _Nonnull typeRawValue;
@end


/// Client applications may adopt this or an inheriting protocol to provide the context of the cached campaign updates. See also MMCampaignContextProtocol.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk33MMCampaignContextProviderProtocol_")
@protocol MMCampaignContextProviderProtocol
@optional
@property (nonatomic, readonly, strong) id <MMCampaignContextProtocol> _Nonnull campaignContext;
@end


/// Client applications that provide client-specific identifiers must adopt this or an inheriting protocol.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk32MMClientIdentityProviderProtocol_")
@protocol MMClientIdentityProviderProtocol
/// Identifier used for oAuth2 client authentication.
@property (nonatomic, readonly, copy) NSString * _Nonnull oAuth2Id;
/// Secret used for oAuth2 client authentication.
@property (nonatomic, readonly, copy) NSString * _Nonnull oAuth2Secret;
@optional
/// Optional client-related identifiers, such ids may be MSISDNs, application session identifiers, SSO tokens, etc.
@property (nonatomic, readonly, copy) NSDictionary<NSString *, NSString *> * _Nullable oClientIds;
@end



/// Protocol that defines the context of a user account status change.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk40MMUserAccountStatusChangeContextProtocol_")
@protocol MMUserAccountStatusChangeContextProtocol
/// Identifier for correlation purposes.
@property (nonatomic, readonly, copy) NSString * _Nonnull correlationIdentifier;
/// The source of the change. For example, a screen that presents a campaign,
/// a profile screen, etc.
@property (nonatomic, readonly, copy) NSString * _Nonnull source;
/// Must return key: value pairs to be used for logging.
@property (nonatomic, readonly, copy) NSDictionary<NSString *, id> * _Nonnull loggingParameters;
@end


/// Base class for private-init classes. Not meant to be instantiated by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk19MMPrivateInitObject")
@interface MMPrivateInitObject : NSObject
/// Returns a string that describes the contents of the receiver.
@property (nonatomic, readonly, copy) NSString * _Nonnull description;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end


/// Identifies a generic (default) context of a user account status change.
SWIFT_CLASS("_TtC13madme_ios_sdk39MMGenericUserAccountStatusChangeContext")
@interface MMGenericUserAccountStatusChangeContext : MMPrivateInitObject <MMUserAccountStatusChangeContextProtocol>
/// Initialize with a correlationIdentifier and source.
- (nonnull instancetype)initWithCorrelationIdentifier:(NSString * _Nonnull)_correlationIdentifier source:(NSString * _Nonnull)_source OBJC_DESIGNATED_INITIALIZER;
/// Identifier for correlation purposes.
@property (nonatomic, readonly, copy) NSString * _Nonnull correlationIdentifier;
/// The source of the change. For example, a screen that presents a campaign,
/// a profile screen, etc.
@property (nonatomic, readonly, copy) NSString * _Nonnull source;
/// Returns key: value logging pairs for the correlationIdentifier and source.
@property (nonatomic, readonly, copy) NSDictionary<NSString *, id> * _Nonnull loggingParameters;
@end


/// Defines a set of potential mAdme notification-processing errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk29MMNotificationProcessingError")
@interface MMNotificationProcessingError : MMError
/// Indicates that the mAdme SDK does not support the notification.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull unsupportedNotification;)
+ (MMError * _Nonnull)unsupportedNotification SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the mAdme SDK was unable to retrieve the media.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull failedToRetrieveMedia;)
+ (MMError * _Nonnull)failedToRetrieveMedia SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the mAdme SDK was unable to schedule a local notification.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull failedToScheduleLocalNotification;)
+ (MMError * _Nonnull)failedToScheduleLocalNotification SWIFT_WARN_UNUSED_RESULT;
/// Indicates that the mAdme SDK was unable to process the action.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull failedToProcessAction;)
+ (MMError * _Nonnull)failedToProcessAction SWIFT_WARN_UNUSED_RESULT;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end

enum MMNotificationProcessingResultState : NSInteger;

/// Protocol that all mAdme notification processing results must conform to. Not meant to be adopted by applications.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk38MMNotificationProcessingResultProtocol_")
@protocol MMNotificationProcessingResultProtocol
/// Unique identifier of the notification processing result.
@property (nonatomic, readonly, copy) NSString * _Nonnull identifier;
/// The state gives an insight into the processing of the notification.
@property (nonatomic, readonly) enum MMNotificationProcessingResultState state;
/// Processing results may contain optional values, e.g., ad presentation results or errors.
@property (nonatomic, readonly, strong) id _Nullable oValue;
@end

/// Possible states of mAdme notification processing results.
typedef SWIFT_ENUM(NSInteger, MMNotificationProcessingResultState, open) {
/// Notification was not processed
  MMNotificationProcessingResultStateNotificationNotProcessed = 0,
/// Notification was processed successfully
  MMNotificationProcessingResultStateNotificationProcessedSucessfully = 1,
/// Notification was processed unsuccessfully
  MMNotificationProcessingResultStateNotificationProcessedUnsuccessfully = 2,
};


@protocol MMSdkDelegateProtocol;
@class UIViewController;
@class NSURL;
@protocol MMUrlProcessingResultProtocol;
@protocol MMUrlSessionEventsProcessingResultProtocol;
@class UIApplication;
@class UIButton;
@class UITextField;

/// mAdme SDK wrapper. Not meant to be instantiated by apps. Please use the sharedInstance singleton instead.
SWIFT_CLASS("_TtC13madme_ios_sdk5MMSdk")
@interface MMSdk : MMPrivateInitObject
/// The mAdme SDK singleton.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMSdk * _Nonnull sharedInstance;)
+ (MMSdk * _Nonnull)sharedInstance SWIFT_WARN_UNUSED_RESULT;
/// The version of the mAdme SDK.
@property (nonatomic, readonly, copy) NSString * _Nonnull version;
/// References the mAdme SDK delegate, which is mandatory.
@property (nonatomic, weak) id <MMSdkDelegateProtocol> _Null_unspecified delegate;
/// Presents a mAdme ad.
/// \param tags A set of tags to be matched.
///
/// \param tagsAggregateQualifier Instructs the mAdme SDK to present an ad that matched either all or any tags.
///
/// \param adPresentationMode Instructs the mAdme SDK to present an ad either directly, or through a notification.
///
/// \param oParentViewController If provided, the mAdme SDK will use it to present the ad.
///
/// \param oResultClosure If provided, the mAdme SDK will use it to report the result of the presentation. For example, if no ad is available, the result will have an adNotPresented state and an noAdAvailable error oValue. If a video ad is viewed the result will have an adViewed state. Or, if a survey is submitted the result will have an adViewedAndTapped state. Note that when multiple notifications are scheduled oResultClosure will be called for each one of them.
///
- (void)presentAdWithTags:(NSSet<NSString *> * _Nonnull)tags tagsAggregateQualifier:(enum MMAggregateQualifier)tagsAggregateQualifier adPresentationMode:(enum MMAdPresentationMode)adPresentationMode oParentViewController:(UIViewController * _Nullable)oParentViewController oResultClosure:(void (^ _Nullable)(id <MMAdPresentationResultProtocol> _Nonnull))oResultClosure;
/// Processes a mAdme notification payload.
/// \param notificationPayload Must be set to a local or remote notification userInfo.
///
/// \param oActionIdentifier If provided, must be set to the notification’s actionIdentifier.
///
/// \param oResultClosure If provided, the mAdme SDK will use it to report
/// the result of the notification processing. For example, if notificationPayload
/// does not correspond to a mAdme notification, the result will have an notificationNotProcessed
/// state and an unsupportedNotification error oValue.
///
- (void)processWithNotificationPayload:(NSDictionary * _Nonnull)notificationPayload oActionIdentifier:(NSString * _Nullable)oActionIdentifier oResultClosure:(void (^ _Nullable)(id <MMNotificationProcessingResultProtocol> _Nonnull))oResultClosure;
/// Configures the mAdme SDK for the processing of remote notifications. Use this API when the client application is in charge of retrieving the remote-notifications registration token. Please make sure that the remote notifications channel is set in the build-time configuration file to e.g., “FCM” or “APNs”, etc.
/// \param with remoteNotificationsRegistrationToken The FCM/APNs/… token.
///
- (void)configureRemoteNotificationsWith:(NSString * _Nonnull)remoteNotificationsRegistrationToken;
/// Processes a mAdme url.
/// \param url The url to process.
///
/// \param oResultClosure If provided, the mAdme SDK will use it to report
/// the result of the url processing. For example, if the url does not correspond
/// to a mAdme url, the result will have an urlNotProcessed state and an oValue
/// set to unsupportedUrl error.
///
///
/// returns:
/// True if the input url can be processed by the mAdme SDK. False otherwise.
/// Note that although redundant, the return value here allows caller applications
/// to return from “openURL” UIApplicationDelegate calls without having to block
/// waiting for oResultClosure to be called.
- (BOOL)processWithUrl:(NSURL * _Nonnull)url oResultClosure:(void (^ _Nullable)(id <MMUrlProcessingResultProtocol> _Nonnull))oResultClosure SWIFT_WARN_UNUSED_RESULT;
/// Ensures that download events are processed correctly. The application MUST call this
/// each time its delegate receives an application:handleEventsForBackgroundURLSession:completionHandler: call.
/// \param identifier Identifier of the mAdme background download session.
///
/// \param resultClosure Closure to be called once the events have been
/// processed. For example, if the session identifier is not a mAdme session
/// identifier, the result will have an eventsNotProcessed state and an oValue
/// set to unsupportedUrlSessionIdentifier error.
///
- (void)handleEventsForBackgroundURLSessionWithIdentifier:(NSString * _Nonnull)identifier resultClosure:(void (^ _Nonnull)(id <MMUrlSessionEventsProcessingResultProtocol> _Nonnull))resultClosure;
/// Allows the mAdme SDK to perform background tasks. The application MUST call this each time its delegate receives an application:performFetchWithCompletionHandler:.
/// \param application Calling application that embeds the mAdme SDK.
///
/// \param performFetchWithCompletionHandler Closure that will be executed on completion of the tasks.
///
- (void)application:(UIApplication * _Nonnull)application performFetchWithCompletionHandler:(void (^ _Nonnull)(UIBackgroundFetchResult))completionHandler;
/// Configures UI attributes of the input button.
/// \param button Button to be configured.
///
/// \param withUIAttributesId Id of the MMConfiguration UIAttributes entry.
///
- (void)configureButton:(UIButton * _Nonnull)button withUIAttributesId:(NSString * _Nonnull)id;
/// Configures UI attributes of the input textField.
/// \param textField TextField to be configured.
///
/// \param withUIAttributesId Id of the MMConfiguration UIAttributes entry.
///
- (void)configureTextField:(UITextField * _Nonnull)textField withUIAttributesId:(NSString * _Nonnull)id;
@end



@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Call once to configure mAdme notification categories.
+ (void)configureNotificationCategories;
@end


@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Use this key to retrieve the set of campaigns from a Campaigns notification.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, copy) NSString * _Nonnull CampaignsKey;)
+ (NSString * _Nonnull)CampaignsKey SWIFT_WARN_UNUSED_RESULT;
@end

enum MMUserAccountStatus : NSInteger;

@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Retrieves the current user account status.
/// \param closure Closure on which the current user account status is reported.
///
- (void)getUserAccountStatusWithClosure:(void (^ _Nonnull)(enum MMUserAccountStatus))closure;
/// Attempts to re-set the user account status.
/// \param to The target user account status.
///
/// \param changeContext The context in which the account status change takes place.
///
/// \param closure Closure on which the resulting user account status is reported.
///
- (void)changeUserAccountStatusTo:(enum MMUserAccountStatus)userAccountStatus changeContext:(id <MMUserAccountStatusChangeContextProtocol> _Nonnull)changeContext closure:(void (^ _Nonnull)(enum MMUserAccountStatus))closure;
@end


SWIFT_AVAILABILITY(ios,introduced=13.0)
@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Call once to configure mAdme for the processing of background refresh tasks.
+ (void)configureBackgroundRefresh SWIFT_AVAILABILITY(ios,introduced=13.0);
@end


SWIFT_AVAILABILITY(ios,introduced=13.0)
@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Call once to configure mAdme for the processing of background processing tasks.
+ (void)configureBackgroundProcessing SWIFT_AVAILABILITY(ios,introduced=13.0);
@end


@interface MMSdk (SWIFT_EXTENSION(madme_ios_sdk))
/// Returns true if configured through MMConfiguration.plist to manage the style of the status bar. False otherwise.
@property (nonatomic, readonly) BOOL managesStatusBarStyle;
/// Returns the status bar style as configured through MMConfiguration.plist. Defaults to <code>default</code> if not configured.
@property (nonatomic, readonly) UIStatusBarStyle configurationStatusBarStyle;
@end


/// Client applications that require custom opt-in/opt-out behavior must adopt this or an inheriting protocol.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk35MMUserAccountStatusDelegateProtocol_")
@protocol MMUserAccountStatusDelegateProtocol
@optional
/// Called when the user account status is about to be changed.
/// \param to The target user account status.
///
/// \param closure Closure to be used by the delegate to allow for the change to be attempted or aborted. If not implemented, the SDK will allow for the change to be attempted.
///
- (void)willPerformUserAccountStatusChangeTo:(enum MMUserAccountStatus)userAccountStatus closure:(void (^ _Nonnull)(BOOL))closure;
@end


/// mAdme SDK umbrella protocol. Client applications should adopt this protocol instead of the inherited protocols.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk21MMSdkDelegateProtocol_")
@protocol MMSdkDelegateProtocol <MMCampaignContextProviderProtocol, MMClientIdentityProviderProtocol, MMUserAccountStatusDelegateProtocol>
@end


/// Defines a set of potential mAdme url-processing errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk20MMUrlProcessingError")
@interface MMUrlProcessingError : MMError
/// Indicates that the mAdme SDK does not support the url.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull unsupportedUrl;)
+ (MMError * _Nonnull)unsupportedUrl SWIFT_WARN_UNUSED_RESULT;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end

enum MMUrlProcessingResultState : NSInteger;

/// Protocol that all mAdme url processing results must conform to. Not meant to be adopted by applications.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk29MMUrlProcessingResultProtocol_")
@protocol MMUrlProcessingResultProtocol
/// The state gives an insight into the processing of the url.
@property (nonatomic, readonly) enum MMUrlProcessingResultState state;
/// Processing results may contain optional values, e.g., errors.
@property (nonatomic, readonly, strong) id _Nullable oValue;
@end

/// Possible states of mAdme url processing results.
typedef SWIFT_ENUM(NSInteger, MMUrlProcessingResultState, open) {
/// Url was not processed
  MMUrlProcessingResultStateUrlNotProcessed = 0,
/// Url was processed successfully
  MMUrlProcessingResultStateUrlProcessedSucessfully = 1,
/// Url was processed unsuccessfully
  MMUrlProcessingResultStateUrlProcessedUnsuccessfully = 2,
};


/// Defines a set of potential mAdme url-session events processing errors. Not meant to be initialized by applications.
SWIFT_CLASS("_TtC13madme_ios_sdk33MMUrlSessionEventsProcessingError")
@interface MMUrlSessionEventsProcessingError : MMError
/// Indicates that the mAdme SDK does not support the url-session identifier.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, strong) MMError * _Nonnull unsupportedUrlSessionIdentifier;)
+ (MMError * _Nonnull)unsupportedUrlSessionIdentifier SWIFT_WARN_UNUSED_RESULT;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end

enum MMUrlSessionEventsProcessingResultState : NSInteger;

/// Protocol that all mAdme url-session events processing results must conform to. Not meant to be adopted by applications.
SWIFT_PROTOCOL("_TtP13madme_ios_sdk42MMUrlSessionEventsProcessingResultProtocol_")
@protocol MMUrlSessionEventsProcessingResultProtocol
/// The state gives an insight into the processing of the events.
@property (nonatomic, readonly) enum MMUrlSessionEventsProcessingResultState state;
/// Processing results may contain optional values, e.g., errors.
@property (nonatomic, readonly, strong) id _Nullable oValue;
@end

/// Possible states of mAdme url-session event processing results.
typedef SWIFT_ENUM(NSInteger, MMUrlSessionEventsProcessingResultState, open) {
/// Events were not processed
  MMUrlSessionEventsProcessingResultStateEventsNotProcessed = 0,
/// Events were processed successfully
  MMUrlSessionEventsProcessingResultStateEventsProcessedSucessfully = 1,
/// Events were processed unsuccessfully
  MMUrlSessionEventsProcessingResultStateEventsProcessedUnsuccessfully = 2,
};

/// Possible states of mAdme user accounts.
typedef SWIFT_ENUM(NSInteger, MMUserAccountStatus, open) {
/// unknown
  MMUserAccountStatusUnknown = 0,
/// activated (opted in)
  MMUserAccountStatusActivated = 1,
/// suspended (opted out)
  MMUserAccountStatusSuspended = 2,
/// terminated
  MMUserAccountStatusTerminated = 3,
};















/// Default campaign context implementation.
SWIFT_CLASS("_TtC13madme_ios_sdk39MMViewedNoSurveyNoRatingCampaignContext")
@interface MMViewedNoSurveyNoRatingCampaignContext : NSObject <MMCampaignContextProtocol>
@property (nonatomic, readonly, copy) NSString * _Nonnull typeRawValue;
- (nonnull instancetype)init OBJC_DESIGNATED_INITIALIZER;
@end






@interface NSNotification (SWIFT_EXTENSION(madme_ios_sdk))
/// Use this as notification name to be informed of cached campaigns updates. See also MMCampaignContextProviderProtocol.
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly) NSNotificationName _Nonnull Campaigns;)
+ (NSNotificationName _Nonnull)Campaigns SWIFT_WARN_UNUSED_RESULT;
@end









@interface UINavigationController (SWIFT_EXTENSION(madme_ios_sdk))
/// Returns the topViewController. Override preferredStatusBarStyle in topViewController to control the style of the status bar.
@property (nonatomic, readonly, strong) UIViewController * _Nullable childViewControllerForStatusBarStyle;
@end




#if __has_attribute(external_source_symbol)
# pragma clang attribute pop
#endif
#pragma clang diagnostic pop
#endif

#endif
